local cql = ClassicQuestLog

ClassicQuestLogRewardButtonMixin = {}

function ClassicQuestLogRewardButtonMixin:OnEnter()
    GameTooltip:SetOwner(self,"ANCHOR_RIGHT")
    if self.objectType=="item" then
        GameTooltip:SetQuestLogItem(self.rewardType,self.rewardIndex,self.questID)
        GameTooltip_ShowCompareItem(GameTooltip)
    elseif self.objectType=="spell" then
        GameTooltip:SetSpellByID(self.id,nil,true)
    elseif self.objectType=="follower" then
        GarrisonFollowerTooltip:ClearAllPoints()
		GarrisonFollowerTooltip:SetPoint("BOTTOMLEFT",self,"TOPRIGHT")
        local data = GarrisonFollowerTooltipTemplate_BuildDefaultDataForID(self.id)
        if data then
		    GarrisonFollowerTooltip_ShowWithData(data)
        end
    elseif self.rewardType=="choice" and self.objectType=="currency" then
        GameTooltip:SetQuestLogCurrency(self.rewardType,self.rewardIndex)
    elseif self.objectType=="currency" and type(self.id)=="table" and self.id.currencyID then
        GameTooltip:SetCurrencyByID(self.id.currencyID,self.id.amount)
    elseif self.objectType=="skill" and self.id then
        GameTooltip:SetText(self.id,1,1,1,true)
    elseif self.objectType=="reputation" and type(self.id)=="table" and self.id.factionName then
        GameTooltip:SetText(format(QUEST_REPUTATION_REWARD_TITLE,self.id.factionName),1,1,1,true)
        GameTooltip:AddLine(format(QUEST_REPUTATION_REWARD_TOOLTIP,self.id.rewardAmount,self.id.factionName),1,0.82,0,true)
    elseif self.objectType=="warmode" then
        GameTooltip:SetText(WAR_MODE_BONUS,1,1,1,true)
        GameTooltip:AddLine(WAR_MODE_BONUS_QUEST,1,0.82,0,true)
    elseif self.objectType=="questSessionBonusReward" then
        GameTooltip:SetItemByID(self.id)
    else
        return
    end
    GameTooltip:Show()
end

function ClassicQuestLogRewardButtonMixin:OnLeave()
    GameTooltip:Hide()
    if GarrisonFollowerTooltip and GarrisonFollowerTooltip:IsVisible() then
        GarrisonFollowerTooltip:Hide()
    end
end

function ClassicQuestLogRewardButtonMixin:OnClick()
    if IsModifiedClick() then
        if self.objectType=="item" then
            ChatEdit_InsertLink(GetQuestLogItemLink(self.rewardType,self.rewardIndex))
            --HandleModifiedItemClick(GetQuestLogItemLink(self.rewardType,self.rewardIndex))
        elseif self.objectType=="spell" then
            ChatEdit_InsertLink(GetSpellLink(self.id))
        elseif self.objectType=="follower" then
            local followerLink = C_Garrison.GetFollowerLinkByID(self.id)
            if followerLink then
                ChatEdit_InsertLink(followerLink)
            end
        end
    end
end
