local cql = ClassicQuestLog

--[[ mixin for options check buttons ]]

ClassicQuestLogCheckButtonMixin = {}

function ClassicQuestLogCheckButtonMixin:OnEnter()
    self.Highlight:Show()
    self.Text:SetTextColor(1,1,1)

    GameTooltip:ClearAllPoints()
	GameTooltip:SetPoint("TOPRIGHT",self,"TOPLEFT",-4,4)
	GameTooltip:SetOwner(self,"ANCHOR_PRESERVE")
    GameTooltip:SetCustomLineSpacing(8)
    GameTooltip:AddLine(self.tooltipTitle,1,1,1,true)
    GameTooltip:AddLine(self.tooltipBody,1,0.82,0,true)
    GameTooltip:Show()
end

function ClassicQuestLogCheckButtonMixin:OnLeave()
    self.Highlight:Hide()
    self.Text:SetTextColor(1,0.82,0)

    GameTooltip:Hide()
end

function ClassicQuestLogCheckButtonMixin:OnMouseDown()
    self.Highlight:Hide()
end

function ClassicQuestLogCheckButtonMixin:OnMouseUp()
    if GetMouseFocus()==self then
        self.Highlight:Show()
    end
end

function ClassicQuestLogCheckButtonMixin:OnClick()
    if self.var then
        cql.settings[self.var] = not cql.settings[self.var]
        if self.var=="ShowDefaultQuestPortrait" then
            if QuestModelScene and QuestModelScene:IsShown() then
                QuestFrame_HideQuestPortrait()
            end
        elseif self.var=="ShowMinimapButton" then
            cql.MinimapButton:Update()
        elseif self.var=="ShowFromKeyBind" then
            cql.BindButton:Setup()
        elseif self.var=="ShowFromMicroButton" then
            cql.MicroButton:Update()
        elseif self.var=="ShowTooltips" then
            if not cql.settings.ShowTooltips then
                cql:RegisterEvent("MODIFIER_STATE_CHANGED")
            else
                cql:UnregisterEvent("MODIFIER_STATE_CHANGED")
            end
        end
        cql:Update()
    end
end
